-- <= == == == == == == == == == == == == =>
-- => Option Registration
-- <= == == == == == == == == == == == == =>

if (not RMDB) then
	RMDB = {
        --parent = UIParent;
        --point = "BOTTOMLEFT";
        --parentPoint = "BOTTOMLEFT";
        x = 500;
        y = 500;
    };
end

local Portfolio = LibStub and LibStub("Portfolio")
if not Portfolio then return end

local function callback(id, value, isGUI, isUpdate) 
	Portfolio.Print(id.." callback( \""..tostring(value).."\", "..tostring(isGUI)..", "..tostring(isUpdate)..")")
end

local function colorCallback(id, color, isGUI, isUpdate) 
	(SELECTED_CHAT_FRAME or DEFAULT_CHAT_FRAME)
		:AddMessage(id.." Updated. callback( { r="..tostring(color.r):format("%.2f")..", g="
		..tostring(color.g):format("%.2f")..", b="..tostring(color.b):format("%.2f")..", opacity="
		..tostring(color.opacity).." }, "..tostring(isGUI)..", "..tostring(isUpdate)..") ", 
		color.r, color.g, color.b) 
end

local optionTable = {
	id="RuneMover";
	text="RuneMover";
	addon="RuneMover";
	about=false;
	options = {
		{
			id = "unlocked";
			text = "Unlock Runes";
			tooltipText = "Check this to unlock the runes so that you can move them freely.";
			type = CONTROLTYPE_CHECKBOX;
			defaultValue = "0";
			callback = RuneMover_Lock
		};
        {
			id = "layout";
			headerText = "Rune Layouts";
			type = CONTROLTYPE_DROPDOWN;
			defaultValue = "0";
			menuList = {
				{
					text = "Horizontal";
                    value = "0";
				};
				{
					text = "Vertical";
					value = "1";
				};
				{
					text = "Vertical Block";
					value = "2";
				};
                {
                    text = "Horizontal Block";
                    value = "4";
                };
				{
					text = "Up Curve";
					value = "3";
				};
                {
                    text = "Down Curve";
                    value = "5";
                };
			};
            callback = RuneMover_Orientation
		};
        {
            id = "images";
            headerText = "Rune Textures";
            type = CONTROLTYPE_DROPDOWN;
            defaultValue = "0";
            menuList = {
                {
					text = "Default";
                    value = "0";
				};
				{
					text = "Beta Runes";
					value = "1";
				};
				{
					text = "DKI Runes";
					value = "2";
				};
				{
					text = "Letter Runes";
					value = "3";
				};
                {
                    text = "Orb Runes";
                    value = "4";
                };
                {
                    text = "Enhanced Beta Runes";
                    value = "5";
                };
                {
                    text = "Japanese Runes";
                    value = "6";
                };
                {
                    text = "Runica Runes";
                    value = "7";
                };
            };
            callback = RuneMover_Images
        };
		{
            id = "scale";
            text = "Rune Scale (%.1f)";
            tooltipText = "Adjust the scale of the runes.\nNote: You must have a scale of 1.2 or higher for OmniCC to work.";
            minText = "Small";
            maxText = "Large";
            minValue = 0.5;
            maxValue = 2.0;
            valueStep = 0.1;
            type = CONTROLTYPE_SLIDER;
            defaultValue = "1.2";
            callback = Slider_ValueChanged
        };
		{
			id = "alphain";
			text = "Alpha In Combat (%.1f)";
			tooltipText = "The transparency of the runes while in combat.";
			minText = "Light";
			maxText = "Solid";
			minValue = 0.1;
			maxValue = 1;
			valueStep = 0.1;
			type = CONTROLTYPE_SLIDER;
			defaultValue = "1";
		};
        {
            id = "alphaout";
            text = "Alpha Out of Combat (%.1f)";
            tooltipText = "The transparency of the runes while out of combat.";
            minText = "Light";
            maxText = "Solid";
            minValue = 0;
            maxValue = 1;
            valueStep = 0.1;
            type = CONTROLTYPE_SLIDER;
            defaultValue = "0.5";
            callback = Alphaout_ValueChanged
        };
	};
	savedVarTable = "RMDB";
}

Portfolio.RegisterOptionSet(optionTable)